%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Progect   :Using Histogram Equilization.
% By        :Manjit Reddy Chintalapalli.
% Professor : Longin Jon Latecki.
% Course    :CIS 601.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Taking an input image 
image=imread('moon.gif');

%Making a Histogram of the image and storing in h
h=imhist(image);

%Transposing the h matrix to make it a row matrix.
h=h';

%Cumulative Distribution function is being implemented to the image 
s=zeros(1,256);% A row matrix is creating with same dimentions of h.
s(1)=h(1)/numel(image);
for i=2:256
    s(i)=s(i-1)+ (h(i)/numel(image));
end

%the original image in stored in a new image
new_image=image;

%using the cumulative distribution the original image is tranformed into a
%new image
for i=1:numel(image)
        j=new_image(i);
        if j==0
            j=1;
        end
        new_image(i)=round(s(j)*255);
end

% These are the outputs showing the difference between the two images and
% their histograms.
figure, imshow(image);
figure, imshow(new_image);
figure, imhist(new_image);
figure, imhist(image);
%End of the assignment
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
